package restkiosk.controladors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import restkiosk.dao.UserDao;
import restkiosk.utils.Excepcions;



@Controller
@RequestMapping(value="/auth")
@Configuration
@ComponentScan("restkiosk.dao")
public class ControladorLogin {
        
	

	@Autowired
	private UserDao userDao;
	
	/**
	 * Handles and retrieves the login JSP page
	 * 
	 * @return the name of the JSP page
	 */
	@RequestMapping(value = "/login", method = RequestMethod.GET)
	@ExceptionHandler({Excepcions.class})
	public String getLoginPage(@RequestParam(value="error", required=false) boolean error, 
			ModelMap model) {

		try {
			// Add an error message to the model if login is unsuccessful
			// The 'error' parameter is set to true based on the when the authentication has failed. 
			// We declared this under the defaultFailureUrl attribute inside the spring-security.xml

			if (error == true) {
				// Assign an error message
				model.put("error", "You have entered an invalid username or password!");
			} else {
				model.put("error", "");
			}
			
			// This will resolve to /WEB-INF/jsp/loginpage.jsp
			return "loginpage";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			throw new Excepcions("Error al verificar les credencials d'accs.");
		}
	}
	
	/**
	 * Handles and retrieves the denied JSP page. This is shown whenever a regular user
	 * tries to access an admin only page.
	 * 
	 * @return the name of the JSP page
	 */
	@RequestMapping(value = "/denied", method = RequestMethod.GET)
	@ExceptionHandler({Excepcions.class})
 	public String getDeniedPage() {
		
		try {
			// This will resolve to /WEB-INF/jsp/deniedpage.jsp
			return "deniedpage";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			throw new Excepcions("Error al verificar les credencials d'accs.");
		}
	}

	
}