package restkiosk.model;

import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.Table;


@Entity
@Table(name="families")
public class Familia {

	@Id
	@GeneratedValue
	@Column(name="IdFamilia")
	private int idFamilia;
	
	@Column(name="Descripcio")
	private String descripcio;

	@Column(name="Visible")
	private boolean visible;

	@Column(name="Ordre")
	private int ordre;

	
	 @OneToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER)
	 @JoinTable(
	            name="familiesrelproductes",
	            joinColumns = @JoinColumn( name="IdFamilia"),
	            inverseJoinColumns = @JoinColumn( name="IdProducte")
	    )
	 private Set<Producte> productes; //= new HashSet<Producte>();
	 
	 	
	 @OneToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER)
	 @JoinTable(
	            name="familiesrelmenus",
	            joinColumns = @JoinColumn( name="IdFamilia"),
	            inverseJoinColumns = @JoinColumn( name="IdMenu")
	    )
	 private Set<Menu> menus;// = new HashSet<Menu>();
	 
	 

	 
	 
	 
	public Familia(){
		this.idFamilia = 0;
		this.descripcio = "";
	}
	
	public Familia(int IdFamilia, String Descripcio){
		this.idFamilia = IdFamilia;
		this.descripcio = Descripcio;
	}

	public int getIdFamilia() {
		return idFamilia;
	}

	public void setIdFamilia(int IdFamilia) {
		this.idFamilia = IdFamilia;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String Descripcio) {
		this.descripcio = Descripcio;
	}

	public boolean isVisible() {
		return visible;
	}

	public void setVisible(boolean visible) {
		this.visible = visible;
	}

	public int getOrdre() {
		return ordre;
	}

	public void setOrdre(int ordre) {
		this.ordre = ordre;
	}

	public Set<Producte> getProductes() {
		return productes;
	}

	public void setProductes(Set<Producte> productes) {
		this.productes = productes;
	}

	public Set<Menu> getMenus() {
		return menus;
	}

	public void setMenus(Set<Menu> menus) {
		this.menus = menus;
	}

	
}
