package restkiosk.utils;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
 
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.authentication.encoding.Md5PasswordEncoder;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.GrantedAuthorityImpl;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import restkiosk.dao.UserDao;
import restkiosk.model.User;

@Controller
@Configuration
@ComponentScan("restkiosk.dao")
public class CustomAuthenticationManager implements AuthenticationManager {
 

 UserDao userDao = new UserDao();
 
 private Md5PasswordEncoder passwordEncoder = new Md5PasswordEncoder();
  
 public Authentication authenticate(Authentication auth)
   throws AuthenticationException {
	 
 
  User user = null;
   
  try {
   user = userDao.cercaUsuari(auth.getName());
  } catch (Exception e) {
   throw new BadCredentialsException("L'usuari no existeix.");
  }
   
  if (  passwordEncoder.isPasswordValid(user.getPassword(), (String) auth.getCredentials(), null) == false ) {
   
   throw new BadCredentialsException("El password s incorrecte.");
  }

    
   
   return new UsernamePasswordAuthenticationToken(
     auth.getName(), 
     auth.getCredentials(), 
     getAuthorities());

 }
  
 /**
  * Retrieves the correct ROLE type depending on the access level, where access level is an Integer.
  * Basically, this interprets the access value whether it's for a regular user or admin.
  * 
  * @param access an integer value representing the access of the user
  * @return collection of granted authorities
  */
  public Collection<GrantedAuthority> getAuthorities() {
   // Create a list of grants for this user
   List<GrantedAuthority> authList = new ArrayList<GrantedAuthority>(2);
    
   // All users are granted with ROLE_USER access
   // Therefore this user gets a ROLE_USER by default
   authList.add(new GrantedAuthorityImpl("ROLE_USER"));
    
   // Check if this user has admin access 
    authList.add(new GrantedAuthorityImpl("ROLE_ADMIN"));
 
   // Return list of granted authorities
   return authList;
   }
 
}